package com.nantian.cloud.jljc.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.nantian.cloud.jljc.entity.TFaLegalInvestigate;
import com.nantian.cloud.jljc.entity.TFaReviewReport;
import com.nantian.cloud.jljc.entity.TFaTechnologyReport;
import com.nantian.cloud.jljc.service.TFaLegalInvestigateService;
import com.nantian.sc.cloud.common.core.util.R;
import com.nantian.sc.cloud.common.log.annotation.SysLog;
import com.nantian.sc.cloud.common.minio.service.MinioTemplate;
import com.nantian.sc.cloud.common.security.service.ScUser;
import com.nantian.sc.cloud.common.security.util.SecurityUtils;
import lombok.AllArgsConstructor;
import org.apache.commons.io.FilenameUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.UUID;

/**
 * <p>
 * 固定资产投资项目节能审查合法性审查报告表 前端控制器
 * </p>
 *
 * @author fyf
 * @since 2022-02-15
 */
@CrossOrigin
@AllArgsConstructor
@RestController
@RequestMapping("/tFaLegalInvestigate")
public class TFaLegalInvestigateController {

    @Autowired
    MinioTemplate minioTemplate;

    @Autowired
    TFaLegalInvestigateService tFaLegalInvestigateService;

    @PostMapping("/fileUpload/{id}")
    @SysLog("根据id上传固定资产投资项目节能审查合法性审查报告表")
    public R fileUpload(@PathVariable Integer id,@RequestParam("file") MultipartFile[] multipartFiles) throws Exception {
        ScUser u = SecurityUtils.getUser();
        if (multipartFiles.length > 0) {
            for (MultipartFile multipartFile : multipartFiles) {
                //获取文件名称
                String fileName = multipartFile.getOriginalFilename();
                //获取文件的后缀
                String extension = "." + FilenameUtils.getExtension(multipartFile.getOriginalFilename());
                //生成新的文件名称
                String newFileName = "HFX" + new SimpleDateFormat("yyyyMMddHHmmss").format(new Date())
                        + UUID.randomUUID().toString()
                        .replace("-", "") + extension;
                //文件的大小
                long size = multipartFile.getSize();
                //文件的类型
                String contentType = multipartFile.getContentType();
                //上传文件
                InputStream inputStream = multipartFile.getInputStream();
                minioTemplate.putObject("jljc", newFileName, inputStream, inputStream.available(), "application/octet-stream");
                //文件信息保存到数据库
                TFaLegalInvestigate tFaLegalInvestigate = new TFaLegalInvestigate();
                tFaLegalInvestigate.setDelFlag(1);
                tFaLegalInvestigate.setExtension(extension);
                tFaLegalInvestigate.setFilePath("jljc/" + newFileName);
                tFaLegalInvestigate.setFileSize(String.valueOf(size));
                tFaLegalInvestigate.setFileType(contentType);
                tFaLegalInvestigate.setNewFileName(newFileName);
                tFaLegalInvestigate.setOldFileName(fileName);
                tFaLegalInvestigate.setDeptId(u.getDeptId());
                tFaLegalInvestigate.setUpdateTime(new Date());
                tFaLegalInvestigate.setUserId(u.getId());
                tFaLegalInvestigate.setUploadPerson(u.getUserRealName());
                tFaLegalInvestigate.setProjectId(id);
                tFaLegalInvestigate.setUploadTime(new Date());
                tFaLegalInvestigateService.save(tFaLegalInvestigate);
                return R.ok();
            }
        } else {
            return R.failed("上传文件为空！");
        }

        return R.ok();
    }

    @GetMapping("/fileDownload/{id}")
    @SysLog("根据id下载固定资产投资项目节能审查合法性审查报告表")
    public R fileDownload(@PathVariable("id") String id) throws IOException {
        TFaLegalInvestigate tFaLegalInvestigate = tFaLegalInvestigateService.getById(id);
        //获取文件名
        String newFileName = tFaLegalInvestigate.getNewFileName();
        //文件下载
        minioTemplate.getObject("jljc",newFileName);
        return R.ok();
    }

    @DeleteMapping("/fileRemove/{id}")
    @SysLog("根据id删除固定资产投资项目节能审查合法性审查报告表")
    public R fileRemove(@PathVariable("id") String id) throws Exception {
        TFaLegalInvestigate tFaLegalInvestigate = tFaLegalInvestigateService.getById(id);
        ScUser u = SecurityUtils.getUser();
        //获取文件名
        String newFileName = tFaLegalInvestigate.getNewFileName();
        tFaLegalInvestigate.setDelFlag(4);
        tFaLegalInvestigate.setUserId(u.getId());
        tFaLegalInvestigate.setUpdateTime(new Date());
        tFaLegalInvestigate.setDeptId(u.getDeptId());
        tFaLegalInvestigateService.updateById(tFaLegalInvestigate);
        //文件删除
        minioTemplate.removeObject("jljc",newFileName);
        return R.ok();
    }

    @GetMapping("/getFileList/{id}")
    @SysLog("根据id获取固定资产投资项目节能审查合法性审查报告表")
    public R getFileList(@PathVariable Integer id){

        List<TFaLegalInvestigate> list = tFaLegalInvestigateService.list(new QueryWrapper<TFaLegalInvestigate>()
                .eq("project_id", id)
                .eq("del_flag", 1));
        return R.ok(list);
    }

}
